//Car.addMethod = function(name, method) {
//  this.prototype[name] = method;
//  return this;
//}
//
//var Car = 
//  function(year) {
//    this.year = year;
//    this.miles = 0;
//  }.
//  addMethod('drive', function(dist) { this.miles += dist; }).
//  addMethod('turn', function(dir) { println('turn ' + dir); });

// Further refactoring...

Object.prototype.addMethod = function(name, method) {
  this.prototype[name] = method;
}

var createClass = function(constr, methods) {
  for(var methodName in methods) {
    constr.addMethod(methodName, methods[methodName]);
  }
  return constr;
}

var Car = 
  createClass(
    function(year) { this.miles = 0; this.year = year;},
    {
      'drive' : function(dist) { this.miles += dist; },
      'turn' : function(dir) { println('turn ' + dir); }
    }
 )

var car = new Car(2011);
println(car.miles);
car.drive(10);
println(car.miles);
car.turn('left');