var findAll = function(list, predicate) {
  var result = [];
  for(var i = 0; i < list.length; i++) {
    if (predicate(list[i])) {
      result.push(list[i]);
    }
  }
  return result;
}

var names = ['Jack', 'Jill', 'Bob'];

var threeLetters = function(name) { return name.length == 3 }

println(findAll(names, threeLetters));

println(findAll(names, function(str) { return str[0] == 'J'; }))

/*
Bob
Jack,Jill
*/